//+------------------------------------------------------------------+
//|                                                  VininI_Fractals |
//|                                Copyright  2009, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Yellow
//#property indicator_width1 2
//#property indicator_width2 2
//---- input parameters 

extern int  Bar=2;
extern int mode=0;


//---- buffers 

double UPPER[];
double LOWER[];


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() { 
   SetIndexBuffer(0, UPPER)      ;
   SetIndexStyle( 0, DRAW_ARROW) ;
   SetIndexArrow( 0, 217)        ;
   SetIndexBuffer(1, LOWER)      ;
   SetIndexStyle( 1, DRAW_ARROW) ;
   SetIndexArrow( 1, 218)        ;
   
   return(0); 
}  

int deinit() { return(0); } 


//+------------------------------------------------------------------+ 
//| Custom indicator iteration function | 
//+------------------------------------------------------------------+ 
int start() { 
   int counted_bars = IndicatorCounted(), i, j, tmp1, tmp2; 

   if (counted_bars < 0) return(-1); 
   if (counted_bars > 0) counted_bars--;
   
   int limit=Bars - counted_bars;
   bool bFind;
   for(i = limit; i >= Bar; i--)    {
      bFind=true;
      if (mode==0) {
         for (j=1;j<=Bar;j++) 
            if (High[i+Bar]<High[i+Bar+j] || High[i+Bar]<High[i+Bar-j]) 
               bFind=false;
      } else {
         for (j=1;j<=Bar;j++) 
            if (High[i+Bar+j-1]<High[i+Bar+j] || High[i+Bar+j-1]<High[i+Bar-j]) 
               bFind=false;
         
      }
      if (bFind)  UPPER[i+Bar]=High[i+Bar];
      
      bFind=true;
      if (mode==0) {
         for (j=1;j<=Bar;j++) 
            if (Low[i+Bar]>Low[i+Bar+j] || Low[i+Bar]>Low[i+Bar-j]) 
               bFind=false;
      } else {
         for (j=1;j<=Bar;j++) 
            if (Low[i+Bar+j-1]>Low[i+Bar+j] || Low[i+Bar+j-1]>Low[i+Bar-j]) 
               bFind=false;
      }
      if (bFind)  LOWER[i+Bar]=Low[i+Bar];

   }
   
   return(0); 
} 
//+------------------------------------------------------------------+


